/*
Project: Arduino W5100 Ethernet Shield, Photocell and temperature sensor LM335Z
Function: Datalogger. Will log data to Micro SD card
*/
//*****************************************************************************
#include <SD.h>//include SD library code
//*****************************************************************************
float tempK;   //stores kelvin temperature
int sensor;    
/*stores sensor value everytime we use the analog read function on the Ethernet Shield, 
  CS is pin 4. Note that even if it's not used as the CS pin, the hardware CS pin (10 on
  most Arduino boards, 53 on the Mega) must be left as an output or the SD library functions will not work.*/
const int chipSelect = 4;//don't change this number.
int analogPin=0; //help us read the analogPin of our INPUTS
//******************************************************************************
void setup(){
Serial.begin(9600);//initialize serial communications at 9600 bps
while (!Serial) {; // wait for serial port to connect, required for Leonardo only
}
Serial.print("Initializing SD card..."); //make sure that the default chip select pin is set to output, even if you don't use it:
pinMode(10, OUTPUT);
if (!SD.begin(chipSelect)) {// see if the card is present and can be initialized:
Serial.println("Card failed, or not present");
return;
}
Serial.println("Card initialized.");
pinMode(0, INPUT);//sets Photoresistor as an INPUT on analog pin A0
pinMode(1, INPUT);//sets Temperature sensor as an INPUT on analog pin A1
}
//*******************************************************************************
void loop()
{
// make a string for assembling the data to log:
String dataString = "";
// reads three sensors and append to the string:
for (analogPin = 0; analogPin < 3; analogPin++){//reads the photoresistor on analog pin A0
if( analogPin==0){
sensor = analogRead(analogPin);//reads the kelvin tempeature on analog pin A1
}
else if(analogPin==1){
tempK = (((analogRead(analogPin)/ 1023.0) * 5.0) * 100.0);//gets value converts to kelvin temperature
sensor = tempK - 273.0;                                   //converts kelvin to celsius minus 1.5 degrees error
}
else{
tempK = (((analogRead(analogPin-1)/ 1023.0) * 5.0) * 100.0);//gets value and converts to kelvin temperature
sensor = ((tempK - 2.5) * 9 / 5) - 459.67;                  //converts kelvin to farenheit
}
dataString += String(sensor);//stores our values
if (analogPin < 2) {
dataString += ",";
}
}

File dataFile = SD.open("datalogger.txt", FILE_WRITE);//open the file. note that only one file can be open at a time.
//you have to close this one before opening another.
if (dataFile) {//if the file is available, write to it.
dataFile.println(dataString);
dataFile.close();
Serial.println(dataString);//print to the serial port
}
else {
Serial.println("error opening datalogger.txt");//if the file isn't open, pop up an error.
}
}
